class BaseSerializableClass(dict):
    _immutableException = Exception("Cannot modify immutable class")

    def __init__(self, **kwargs):
        dict.__init__(self, **kwargs)

    def __getattr__(self, attr):
        return self[attr]

    def __setattr__(self, key, value):
        raise self._immutableException

    def __setitem__(self, key, value):
        raise self._immutableException

    def __delattr__(self, item):
        raise self._immutableException

    def __delitem__(self, key):
        raise self._immutableException

    def __hash__(self):
        hash_ = 0
        for pair in self.items():
            hash_ ^= hash(pair)
        return hash_
