import alembic.config
import os

from index_registry.utils.config import Config
from index_registry.utils.db import get_engine
from index_registry.sql.models import Base


def db_upgrade(config: Config, target: str='head'):
    alembic_cfg = alembic.config.Config()

    alembic_cfg.set_main_option("script_location",
                                os.path.join(os.path.dirname(os.path.abspath(__file__)), "../alembic"))

    engine = get_engine(config)
    with engine.begin() as connection:
        alembic_cfg.attributes['connection'] = connection

        alembic.config.command.upgrade(alembic_cfg, target)


def create_alembic_rev(config, desc):  # pragma: no cover
    alembic_cfg = alembic.config.Config()

    alembic_cfg.set_main_option("script_location",
                                os.path.join(os.path.dirname(os.path.abspath(__file__)), "../alembic"))

    engine = get_engine(config)
    Base.metadata.create_all(engine)

    with engine.begin() as connection:
        alembic_cfg.attributes['connection'] = connection

        alembic.config.command.revision(alembic_cfg, message=desc, autogenerate=True)
